# dehub-remote

This directory provides a simple Docker image which can be spun up to run a
dehub-enabled git http remote server. Commits which are pushed to this server
will be automatically verified using `dehub verify`.

The docker image is also being hosted on docker hub at
[mediocregopher/dehub-remote][dehub-remote]. Proper image tagging/versioning
coming soon!

[dehub-remote]: https://hub.docker.com/repository/docker/mediocregopher/dehub-remote

## Usage

Running the following:

```
docker run \
    --name dehub \
    -v /opt/dehub/repos:/repos \
    -p 8080:80 \
    mediocregopher/dehub-remote repo-a.git repo-b.git
```

Will start an http server on port 8080, using `/opt/dehub/repos` to store all
repo folders. It will then initialize repo directories at
`/opt/dehub/repos/repo-a.git` and `/opt/dehub/repos/repo-b.git`, if they arent
already there.

## Extras

For convenience the docker image also includes the
[git-http-server](../git-http-server/) binary.

## Contributors

The Dockerfile being used is based on
[gitbox](https://github.com/nmarus/docker-gitbox), so thank you to nmarus for
the great work there.
