package main

import (
	"context"

	"dehub.dev/src/dehub.git/cmd/dehub/dcmd"
)

func main() {
	cmd := dcmd.New()
	cmd.SubCmd("init", "Initialize a new repository in a directory", cmdInit)
	cmd.SubCmd("commit", "Commits staged changes to the head of the current branch", cmdCommit)
	cmd.SubCmd("verify", "Verifies one or more commits as having the proper credentials", cmdVerify)
	cmd.SubCmd("hook", "Use dehub as a git hook", cmdHook)
	cmd.SubCmd("combine", "Combine multiple change and credential commits into a single commit", cmdCombine)

	cmd.Run(func() (context.Context, error) {
		return context.Background(), nil
	})
}
